/* hello.c 
 * Copyright (C) 1998 by Ori Pomerantz
 * 
 * "Hello, world" - the kernel module version. 
 */

/* The necessary header files */

/* Standard in kernel modules */
#include <linux/kernel.h>   /* We're doing kernel work */
#include <linux/module.h>   /* Specifically, a module */
#include "hello.h"



/* Deal with CONFIG_MODVERSIONS */
#if CONFIG_MODVERSIONS==1
#define MODVERSIONS
#include <linux/modversions.h>
#endif        


my_type_t mydata;

/* Initialize the module */
int init_module()
{
	
  mydata.fooptr = 10;
  mydata.barptr = 100;
   
  printk("Hello, world - this is the kernel speaking :: foo %d bar %d\n", mydata.fooptr, mydata.barptr);

  inter_module_register(MY_STRING, THIS_MODULE, &mydata);
  (void) inter_module_put(MY_STRING);

  mydata.fooptr = 123;
  mydata.barptr = 321;



  

  /* If we return a non zero value, it means that 
   * init_module failed and the kernel module 
   * can't be loaded */
  return 0;
}


/* Cleanup - undid whatever init_module did */
void cleanup_module()
{

  inter_module_unregister(MY_STRING);
  printk("Short is the life of a kernel module\n");
}

MODULE_LICENSE("GPL");
