/* hello.c 
 * Copyright (C) 1998 by Ori Pomerantz
 * 
 * "Hello, world" - the kernel module version. 
 */

/* The necessary header files */

/* Standard in kernel modules */
#include <linux/kernel.h>   /* We're doing kernel work */
#include <linux/module.h>   /* Specifically, a module */
#include "hello.h"



/* Deal with CONFIG_MODVERSIONS */
#if CONFIG_MODVERSIONS==1
#define MODVERSIONS
#include <linux/modversions.h>
#endif        


my_type_t *dataptr;
int *modified;


/* Initialize the module */
int init_module()
{
	int foo;
	int bar;

	dataptr = (my_type_t *)inter_module_get(MY_STRING);

	foo = dataptr->fooptr;
	bar = dataptr->barptr;

  printk("Hello 1, world - this is the kernel speaking :: foo %d bar %d\n",foo,bar);
	
	
        (void)inter_module_put(MY_STRING);
	
	dataptr = (my_type_t *)inter_module_get(MY_STRING);

	foo = dataptr->fooptr;
	bar = dataptr->barptr;
	
  printk("Hello 2, world - this is the kernel speaking :: foo %d bar %d\n",foo,bar);

  /* If we return a non zero value, it means that 
   * init_module failed and the kernel module 
   * can't be loaded */
  return 0;
}


/* Cleanup - undid whatever init_module did */
void cleanup_module()
{
  printk("Short is the life of a kernel module\n");
}

MODULE_LICENSE("GPL");
